require './spec/spec_helper'

RSpec.describe Saper::Actions::AppendWith do
  let :subject do
    Saper::Actions::AppendWith.new('!')
  end
  context ".type" do
    it "returns append_with" do
      expect(described_class.type).to eq 'append_with'
    end
  end
  context ".accepts?(:atom)" do
    it "returns false" do
      expect(described_class.accepts?(:atom)).to be false
    end
  end
  context ".accepts?(:document)" do
    it "returns false" do
      expect(described_class.accepts?(:document)).to be false
    end
  end
  context ".accepts?(:html)" do
    it "returns false" do
      expect(described_class.accepts?(:html)).to be false
    end
  end
  context ".accepts?(:json)" do
    it "returns false" do
      expect(described_class.accepts?(:json)).to be false
    end
  end
  context ".accepts?(:markdown)" do
    it "returns false" do
      expect(described_class.accepts?(:markdown)).to be false
    end
  end
  context ".accepts?(:nothing)" do
    it "returns false" do
      expect(described_class.accepts?(:nothing)).to be false
    end
  end
  context ".accepts?(:text)" do
    it "returns true " do
      expect(described_class.accepts?(:text)).to be true
    end
  end
  context ".accepts?(:time)" do
    it "returns false" do
      expect(described_class.accepts?(:time)).to be false
    end
  end
  context ".accepts?(:url)" do
    it "returns false" do
      expect(described_class.accepts?(:url)).to be false
    end
  end
  context ".accepts?(:xml)" do
    it "returns false" do
      expect(described_class.accepts?(:xml)).to be false
    end
  end
  context ".output_for(:atom)" do
    it "returns :nothing" do
      expect(described_class.output_for(:atom)).to be :nothing
    end
  end
  context ".output_for(:document)" do
    it "returns :nothing" do
      expect(described_class.output_for(:document)).to be :nothing
    end
  end
  context ".output_for(:html)" do
    it "returns :nothing" do
      expect(described_class.output_for(:html)).to be :nothing
    end
  end
  context ".output_for(:json)" do
    it "returns :nothing" do
      expect(described_class.output_for(:json)).to be :nothing
    end
  end
  context ".output_for(:markdown)" do
    it "returns :nothing" do
      expect(described_class.output_for(:markdown)).to be :nothing
    end
  end
  context ".output_for(:text)" do
    it "returns :text" do
      expect(described_class.output_for(:text)).to be :text
    end
  end
  context ".output_for(:time)" do
    it "returns :nothing" do
      expect(described_class.output_for(:time)).to be :nothing
    end
  end
  context ".output_for(:url)" do
    it "returns :nothing" do
      expect(described_class.output_for(:url)).to be :nothing
    end
  end
  context ".output_for(:xml)" do
    it "returns :nothing" do
      expect(described_class.output_for(:xml)).to be :nothing
    end
  end
  context ".returns_multiple_items?" do
    it "returns false" do
      expect(described_class.returns_multiple_items?).to be false
    end
  end
  context ".new(nil)" do
    it "raises InvalidArgument" do
      expect { described_class.new(nil) }.to raise_error Saper::InvalidArgument
    end
  end
  context ".new(Numeric)" do
    it "raises InvalidArgument" do
      expect { described_class.new(2) }.to raise_error Saper::InvalidArgument
    end
  end
  context ".new(Hash)" do
    it "raises InvalidArgumenth" do
      expect { described_class.new({}) }.to raise_error Saper::InvalidArgument
    end
  end
  context ".new(Array)" do
    it "raises InvalidArgument" do
      expect { described_class.new([]) }.to raise_error Saper::InvalidArgument
    end
  end
  context ".new(String)" do
    it "returns Action instance" do
      expect(described_class.new("!")).to be_a Saper::Action
    end
  end
  context "#run(nil)" do
    it "raises InvalidInput" do
      expect { subject.run(nil) }.to raise_error Saper::InvalidInput
    end
  end
  context "#run(Numeric)" do
    it "raises InvalidInput" do
      expect { subject.run(1) }.to raise_error Saper::InvalidInput
    end
  end
  context "#run(String)" do
    it "returns Text instance" do
      expect(subject.run('string')).to be_a Saper::Items::Text
    end
    it "returns valid output" do
      expect(subject.run('string').to_s).to eq 'string!'
    end
  end
  context "#run(Text)" do
    it "returns valid output" do
      expect(subject.run(Saper::Items::Text.new('string'))).to eq 'string!'
    end
  end
end