require './spec/spec_helper'

RSpec.describe Saper::Actions::ConvertToJSON do
  let :subject do
    Saper::Actions::ConvertToJSON.new
  end
  context ".type" do
    it "returns convert_to_json" do
      expect(described_class.type).to eq 'convert_to_json'
    end
  end
  context ".accepts?(:atom)" do
    it "returns false" do
      expect(described_class.accepts?(:atom)).to be false
    end
  end
  context ".accepts?(:document)" do
    it "returns false" do
      expect(described_class.accepts?(:document)).to be true
    end
  end
  context ".accepts?(:html)" do
    it "returns false" do
      expect(described_class.accepts?(:html)).to be false
    end
  end
  context ".accepts?(:json)" do
    it "returns false" do
      expect(described_class.accepts?(:json)).to be false
    end
  end
  context ".accepts?(:markdown)" do
    it "returns false" do
      expect(described_class.accepts?(:markdown)).to be false
    end
  end
  context ".accepts?(:nothing)" do
    it "returns false" do
      expect(described_class.accepts?(:nothing)).to be false
    end
  end
  context ".accepts?(:text)" do
    it "returns true " do
      expect(described_class.accepts?(:text)).to be true
    end
  end
  context ".accepts?(:time)" do
    it "returns false" do
      expect(described_class.accepts?(:time)).to be false
    end
  end
  context ".accepts?(:url)" do
    it "returns false" do
      expect(described_class.accepts?(:url)).to be false
    end
  end
  context ".accepts?(:xml)" do
    it "returns false" do
      expect(described_class.accepts?(:xml)).to be false
    end
  end
  context ".output_for(:atom)" do
    it "returns :nothing" do
      expect(described_class.output_for(:atom)).to be :nothing
    end
  end
  context ".output_for(:document)" do
    it "returns :nothing" do
      expect(described_class.output_for(:document)).to be :json
    end
  end
  context ".output_for(:html)" do
    it "returns :nothing" do
      expect(described_class.output_for(:html)).to be :nothing
    end
  end
  context ".output_for(:json)" do
    it "returns :nothing" do
      expect(described_class.output_for(:json)).to be :nothing
    end
  end
  context ".output_for(:markdown)" do
    it "returns :nothing" do
      expect(described_class.output_for(:markdown)).to be :nothing
    end
  end
  context ".output_for(:text)" do
    it "returns :text" do
      expect(described_class.output_for(:text)).to be :json
    end
  end
  context ".output_for(:time)" do
    it "returns :nothing" do
      expect(described_class.output_for(:time)).to be :nothing
    end
  end
  context ".output_for(:url)" do
    it "returns :nothing" do
      expect(described_class.output_for(:url)).to be :nothing
    end
  end
  context ".output_for(:xml)" do
    it "returns :nothing" do
      expect(described_class.output_for(:xml)).to be :nothing
    end
  end
  context ".returns_multiple_items?" do
    it "returns false" do
      expect(described_class.returns_multiple_items?).to be false
    end
  end
  context "#run(nil)" do
    it "raises InvalidInput" do
      expect { subject.run(nil) }.to raise_error Saper::InvalidInput
    end
  end
  context "#run(Numeric)" do
    it "raises InvalidInput" do
      expect { subject.run(2) }.to raise_error Saper::InvalidInput
    end
  end
  context "#run(invalid String)" do
    it "raises InvalidOutput" do
      expect { subject.run('not json') }.to raise_error Saper::InvalidOutput
    end
  end
  context "#run(valid String)" do
    it "returns JSON instance" do
      expect(subject.run('{"test":"ok"}')).to be_a Saper::Items::JSON
    end
  end
  context "#run(valid Text)" do
    it "returns JSON instance" do
      expect(subject.run(Saper::Items::Text.new('{"test":"ok"}'))).to be_a Saper::Items::JSON
    end
  end
end