require './spec/spec_helper'

RSpec.describe Saper::Actions::CreateAtom do
  let :subject do
    Saper::Actions::CreateAtom.new
  end
  let :runtime do
    Saper::Runtime.new :test => 'ok'
  end
  context ".type" do
    it "returns create_atom" do
      expect(described_class.type).to eq 'create_atom'
    end
  end
  context ".accepts?(:atom)" do
    it "returns true" do
      expect(described_class.accepts?(:atom)).to be true
    end
  end
  context ".accepts?(:html)" do
    it "returns true" do
      expect(described_class.accepts?(:html)).to be true
    end
  end
  context ".accepts?(:json)" do
    it "returns true" do
      expect(described_class.accepts?(:json)).to be true
    end
  end
  context ".accepts?(:markdown)" do
    it "returns true" do
      expect(described_class.accepts?(:markdown)).to be true
    end
  end
  context ".accepts?(:nothing)" do
    it "returns true" do
      expect(described_class.accepts?(:nothing)).to be true
    end
  end
  context ".accepts?(:text)" do
    it "returns true" do
      expect(described_class.accepts?(:text)).to be true
    end
  end
  context ".accepts?(:time)" do
    it "returns true" do
      expect(described_class.accepts?(:time)).to be true
    end
  end
  context ".accepts?(:url)" do
    it "returns true" do
      expect(described_class.accepts?(:url)).to be true
    end
  end
  context ".accepts?(:xml)" do
    it "returns true" do
      expect(described_class.accepts?(:xml)).to be true
    end
  end
  context ".output_for(:atom)" do
    it "returns :atom" do
      expect(described_class.output_for(:atom)).to be :atom
    end
  end
  context ".output_for(:document)" do
    it "returns :atom" do
      expect(described_class.output_for(:document)).to be :atom
    end
  end
  context ".output_for(:html)" do
    it "returns :atom" do
      expect(described_class.output_for(:html)).to be :atom
    end
  end
  context ".output_for(:json)" do
    it "returns :atom" do
      expect(described_class.output_for(:json)).to be :atom
    end
  end
  context ".output_for(:markdown)" do
    it "returns :atom" do
      expect(described_class.output_for(:markdown)).to be :atom
    end
  end
  context ".output_for(:text)" do
    it "returns :atom" do
      expect(described_class.output_for(:text)).to be :atom
    end
  end
  context ".output_for(:time)" do
    it "returns :atom" do
      expect(described_class.output_for(:time)).to be :atom
    end
  end
  context ".output_for(:url)" do
    it "returns :atom" do
      expect(described_class.output_for(:url)).to be :atom
    end
  end
  context ".output_for(:xml)" do
    it "returns :atom" do
      expect(described_class.output_for(:xml)).to be :atom
    end
  end
  context ".returns_multiple_items?" do
    it "returns false" do
      expect(described_class.returns_multiple_items?).to be false
    end
  end
  context ".new()" do
    it "raises no errors" do
      expect { described_class.new }.to_not raise_error
    end
  end
  context "#run(nil)" do
    it "returns Saper::Atom" do
      expect(subject.run(nil)).to be_a Saper::Items::Atom
    end
  end
  context "#run(nil, Runtime)" do
    it "returns Saper::Atom" do
      expect(subject.run(nil, runtime)).to be_a Saper::Items::Atom
    end
    it "returns valid output" do
      expect(subject.run(nil, runtime).to_native).to eq :test => 'ok'
    end
  end
end