require './spec/spec_helper'

RSpec.describe Saper::Actions::Fetch do
  let :subject do
    Saper::Actions::Fetch.new
  end
  context ".type" do
    it "returns fetch" do
      expect(described_class.type).to eq 'fetch'
    end
  end
  context ".accepts?(:atom)" do
    it "returns false" do
      expect(described_class.accepts?(:atom)).to be false
    end
  end
  context ".accepts?(:html)" do
    it "returns false" do
      expect(described_class.accepts?(:html)).to be false
    end
  end
  context ".accepts?(:json)" do
    it "returns false" do
      expect(described_class.accepts?(:json)).to be false
    end
  end
  context ".accepts?(:markdown)" do
    it "returns false" do
      expect(described_class.accepts?(:markdown)).to be false
    end
  end
  context ".accepts?(:nothing)" do
    it "returns false" do
      expect(described_class.accepts?(:nothing)).to be false
    end
  end
  context ".accepts?(:text)" do
    it "returns true" do
      expect(described_class.accepts?(:text)).to be true
    end
  end
  context ".accepts?(:time)" do
    it "returns false" do
      expect(described_class.accepts?(:time)).to be false
    end
  end
  context ".accepts?(:url)" do
    it "returns true" do
      expect(described_class.accepts?(:url)).to be true
    end
  end
  context ".accepts?(:xml)" do
    it "returns false" do
      expect(described_class.accepts?(:xml)).to be false
    end
  end
  context ".output_for(:atom)" do
    it "returns :nothing" do
      expect(described_class.output_for(:atom)).to be :nothing
    end
  end
  context ".output_for(:document)" do
    it "returns :nothing" do
      expect(described_class.output_for(:document)).to be :nothing
    end
  end
  context ".output_for(:html)" do
    it "returns :nothing" do
      expect(described_class.output_for(:html)).to be :nothing
    end
  end
  context ".output_for(:json)" do
    it "returns :nothing" do
      expect(described_class.output_for(:json)).to be :nothing
    end
  end
  context ".output_for(:markdown)" do
    it "returns :nothing" do
      expect(described_class.output_for(:markdown)).to be :nothing
    end
  end
  context ".output_for(:text)" do
    it "returns :document" do
      expect(described_class.output_for(:text)).to be :document
    end
  end
  context ".output_for(:time)" do
    it "returns :nothing" do
      expect(described_class.output_for(:time)).to be :nothing
    end
  end
  context ".output_for(:url)" do
    it "returns :document" do
      expect(described_class.output_for(:url)).to be :document
    end
  end
  context ".output_for(:xml)" do
    it "returns :nothing" do
      expect(described_class.output_for(:xml)).to be :nothing
    end
  end
  context ".returns_multiple_items?" do
    it "returns false" do
      expect(described_class.returns_multiple_items?).to be false
    end
  end
  context ".new()" do
    it "raises no errors" do
      expect { described_class.new }.to_not raise_error
    end
  end
  context "#run(nil)" do
    it "raises InvalidInput" do
      expect { subject.run(nil) }.to raise_error Saper::InvalidInput
    end
  end
end