require './spec/spec_helper'

RSpec.describe Saper::Actions::Nothing do
  context ".type" do
    it "returns nothing" do
      expect(described_class.type).to eq 'nothing'
    end
  end
  context ".accepts?(:atom)" do
    it "returns true" do
      expect(described_class.accepts?(:atom)).to be true
    end
  end
  context ".accepts?(:html)" do
    it "returns true" do
      expect(described_class.accepts?(:html)).to be true
    end
  end
  context ".accepts?(:json)" do
    it "returns true" do
      expect(described_class.accepts?(:json)).to be true
    end
  end
  context ".accepts?(:markdown)" do
    it "returns true" do
      expect(described_class.accepts?(:markdown)).to be true
    end
  end
  context ".accepts?(:nothing)" do
    it "returns true" do
      expect(described_class.accepts?(:nothing)).to be true
    end
  end
  context ".accepts?(:text)" do
    it "returns true" do
      expect(described_class.accepts?(:text)).to be true
    end
  end
  context ".accepts?(:time)" do
    it "returns true" do
      expect(described_class.accepts?(:time)).to be true
    end
  end
  context ".accepts?(:url)" do
    it "returns true" do
      expect(described_class.accepts?(:url)).to be true
    end
  end
  context ".accepts?(:xml)" do
    it "returns true" do
      expect(described_class.accepts?(:xml)).to be true
    end
  end
  context ".output_for(:atom)" do
    it "returns :atom" do
      expect(described_class.output_for(:atom)).to be :atom
    end
  end
  context ".output_for(:document)" do
    it "returns :document" do
      expect(described_class.output_for(:document)).to be :document
    end
  end
  context ".output_for(:html)" do
    it "returns :html" do
      expect(described_class.output_for(:html)).to be :html
    end
  end
  context ".output_for(:json)" do
    it "returns :json" do
      expect(described_class.output_for(:json)).to be :json
    end
  end
  context ".output_for(:markdown)" do
    it "returns :markdown" do
      expect(described_class.output_for(:markdown)).to be :markdown
    end
  end
  context ".output_for(:text)" do
    it "returns :text" do
      expect(described_class.output_for(:text)).to be :text
    end
  end
  context ".output_for(:time)" do
    it "returns :time" do
      expect(described_class.output_for(:time)).to be :time
    end
  end
  context ".output_for(:url)" do
    it "returns :url" do
      expect(described_class.output_for(:url)).to be :url
    end
  end
  context ".output_for(:xml)" do
    it "returns :xml" do
      expect(described_class.output_for(:xml)).to be :xml
    end
  end
  context ".returns_multiple_items?" do
    it "returns false" do
      expect(described_class.returns_multiple_items?).to be false
    end
  end
  context ".new(nil)" do
    it "raises no errors" do
      expect { described_class.new(nil) }.to_not raise_error
    end
  end
  context "#run(nil)" do
    it "raises no errors" do
      expect { subject.run(nil) }.to_not raise_error
    end
    it "returns nil" do
      expect(subject.run(nil)).to be_nil
    end
  end
  context "#run(String)" do
    it "returns same string" do
      expect(subject.run("abcde")).to eq 'abcde'
    end
  end
end