require './spec/spec_helper'

RSpec.describe Saper::Action do
  context ".[](invalid)" do
    it "raises ActionNotFound" do
      expect { Saper::Action[:unknown] }.to raise_error Saper::ActionNotFound
    end
  end
  context ".new(invalid)" do
    it "raises ActionNotFound" do
      expect { Saper::Action.new(:unknown) }.to raise_error Saper::ActionNotFound
    end
  end
  context ".new(valid)" do
    it "returns Action" do
      expect(Saper::Action.new(:nothing)).to be_a Saper::Actions::Nothing
    end
  end
  context ".unserialize(nil)" do
    it "raises InvalidAction" do
      expect { Saper::Action.unserialize(nil) }.to raise_error Saper::InvalidAction
    end
  end
  context ".unserialize(Hash)" do
    it "returns Action" do
      expect(Saper::Action.unserialize({ :type => :nothing })).to be_a Saper::Action
    end
  end
  context ".unserialize(Array)" do
    it "returns an Array" do
      expect(Saper::Action.unserialize([{ :type => :nothing }, { :type => :nothing }])).to be_a Array
    end
  end
end