require './spec/spec_helper'

RSpec.describe Saper::Browser do
  let :subject do
    Saper::Browser.new
  end
  context "#history" do
    it "returns an empty array by default" do
      expect(subject.history).to eq []
    end
  end
  context "#headers" do
    it "returns an empty Hash by default" do
      expect(subject.headers).to eq({})
    end
  end
  context "#received" do
    it "returns zero by default" do
      expect(subject.received).to eq 0
    end
  end
  context "#sent" do
    it "returns zero by default" do
      expect(subject.sent).to eq 0
    end
  end
  context "#agent" do
    it "returns User-Agent string" do
      expect(subject.agent).to include 'Mozilla'
    end
  end
end