require './spec/spec_helper'

RSpec.describe "Simple Invalid Recipe" do
  let :recipe do
    Saper::Recipe.parse do
      set_input "<p>one</p><p>two</p>"
      convert_to_html
      append_with "!"
      prepend_with "!"
    end
  end
  let :result do
    recipe.run
  end
  it "returns Result" do
    expect(result).to be_a Saper::Result
  end
  it "#multiple? returns false" do
    expect(result).to_not be_multiple
  end
  it "#success? returns false" do
    expect(result).to_not be_success
  end
  it "#failure? returns true" do
    expect(result).to be_failure
  end
  it "#size returns 1" do
    expect(result.size).to eq 1
  end
  it "#to_native returns nil" do
    expect(result.to_native).to be_nil
  end
  it "#to_saper returns Saper::Items::Nothing" do
    expect(result.to_saper).to be_a Saper::Items::Nothing
  end
  it "#to_json returns valid String" do
    expect(result.to_json).to eq 'null'
  end
end

RSpec.describe "Simple Invalid Recipe" do
  let :recipe do
    Saper::Recipe.parse do
      set_input "<p>one</p><p>two</p>"
      convert_to_html
      find "a"
    end
  end
  let :result do
    recipe.run
  end
  it "returns Result" do
    expect(result).to be_a Saper::Result
  end
  it "#multiple? returns false" do
    expect(result).to_not be_multiple
  end
  it "#success? returns false" do
    expect(result).to_not be_success
  end
  it "#failure? returns true" do
    expect(result).to be_failure
  end
  it "#size returns 1" do
    expect(result.size).to eq 1
  end
  it "#to_native return nil" do
    expect(result.to_native).to be_nil
  end
  it "#to_saper returns nil" do
    expect(result.to_saper).to be_nil
  end
  it "#to_json returns valid JSON" do
    expect(result.to_json).to eq 'null'
  end
end