require './spec/spec_helper'

RSpec.describe "Simple Valid Recipe" do
  let :recipe do
    Saper::Recipe.parse do
      set_input "<p>one</p><p>two</p>"
      convert_to_html
      find "p"
      get_contents
    end
  end
  let :result do
    recipe.run
  end
  it "returns Result" do
    expect(result).to be_a Saper::Result
  end
  it "#multiple? returns true" do
    expect(result).to be_multiple
  end
  it "#success? returns true" do
    expect(result).to be_success
  end
  it "#failure? returns false" do
    expect(result).to_not be_failure
  end
  it "#size returns 2" do
    expect(result.size).to eq 2
  end
  it "#to_native returns valid Array" do
    expect(result.to_native).to eq ["one","two"]
  end
  it "#to_saper returns valid Array" do
    expect(result.to_saper).to eq [Saper::Items::Text.new("one"),Saper::Items::Text.new("two")]
  end
  it "#to_json returns valid String" do
    expect(result.to_json).to eq '["one","two"]'
  end
end