require './spec/spec_helper'

RSpec.describe Saper::Items::Markdown do
  let :html do
    Saper::Items::HTML.new('<p>test</p>')
  end
  let :subject do
    Saper::Items::Markdown.new(html)
  end
  context ".new(nil)" do
    it "raises InvalidItem" do
      expect { Saper::Items::Markdown.new(nil) }.to raise_error Saper::InvalidItem
    end
  end
  context "new('')" do
    it "raises InvalidItem" do
      expect { Saper::Items::Markdown.new("") }.to raise_error Saper::InvalidItem
    end
  end
  context ".new(String)" do
    it "returns Markdown" do
      expect { Saper::Items::Markdown.new("string") }.to raise_error Saper::InvalidItem
    end
  end
  context "#to_native" do
    it "returns underlying String" do
      expect(subject.to_native).to eq 'test'
    end
  end
  context "#to_s" do
    it "returns underlying String" do
      expect(subject.to_s).to eq 'test'
    end
  end
  context "#==" do
    it "returns true for a matching string" do
      expect(subject.to_native).to eq "test"
    end
  end
end
